commit 55df8e954ef9c07b5c158d263c9fc6774245cac1
Author: freddy77 <freddy77>
Date:   Thu Apr 8 08:19:16 2010 +0000

    fix tsql and variant type

diff --git a/ChangeLog b/ChangeLog
index 02ded3d..c4f5737 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Thu Apr  8 10:17:24 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/apps/tsql.c src/tds/token.c:
+	- fix tsql and variant type
+
 Thu Apr  8 09:36:21 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/token.c: Avoid hang on variant type if conversion enabled
 
@@ -2378,4 +2382,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3004 2010/04/08 07:36:49 freddy77 Exp $
+$Id: ChangeLog,v 1.3005 2010/04/08 08:19:16 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index 7bbb2c8..b81474e 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -21,7 +21,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.332 2010/04/05 18:49:25 jklowden Exp $ */
+/* $Id: tds.h,v 1.333 2010/04/08 08:19:16 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -920,6 +920,7 @@ typedef struct tds_blob
  */
 typedef struct tds_variant
 {
+	/* this MUST have same position and place of textvalue in tds_blob */
 	TDS_CHAR *data;
 	TDS_INT size;
 	TDS_INT data_len;
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index a1d716b..26574fb 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -87,7 +87,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.132 2010/01/12 15:43:17 jklowden Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.133 2010/04/08 08:19:16 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -237,7 +237,7 @@ do_query(TDSSOCKET * tds, char *buf, int opt_flags)
 					ctype = tds_get_conversion_type(col->column_type, col->column_size);
 
 					src = col->column_data;
-					if (is_blob_col(col))
+					if (is_blob_col(col) && col->column_type != SYBVARIANT)
 						src = (unsigned char *) ((TDSBLOB *) src)->textvalue;
 					srclen = col->column_cur_size;
 
diff --git a/src/tds/token.c b/src/tds/token.c
index d62866a..c51e80b 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.382 2010/04/08 07:36:49 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.383 2010/04/08 08:19:16 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -81,6 +81,17 @@ static int determine_adjusted_size(const TDSICONV * char_conv, int size);
 static /*@observer@*/ const char *tds_pr_op(int op);
 static int tds_alloc_get_string(TDSSOCKET * tds, /*@special@*/ char **string, int len) /*allocates *string*/;
 
+#if ENABLE_EXTRA_CHECKS
+
+#if defined(__GNUC__) && __GNUC__ >= 2
+#define COMPILE_CHECK(name,check) \
+    extern int name[(check)?1:-1] __attribute__ ((unused))
+#else
+#define COMPILE_CHECK(name,check) \
+    extern int name[(check)?1:-1]
+#endif
+
+#endif
 
 /**
  * \ingroup libtds
@@ -2037,6 +2048,11 @@ tds9_get_varmax(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	return TDS_SUCCEED;
 }
 
+#if ENABLE_EXTRA_CHECKS
+COMPILE_CHECK(tds_variant_size,  sizeof(((TDSVARIANT*)0)->data) == sizeof(((TDSBLOB*)0)->textvalue));
+COMPILE_CHECK(tds_variant_offset,(TDS_INTPTR)(&((TDSVARIANT*)0)->data) == (TDS_INTPTR)(&((TDSBLOB*)0)->textvalue));
+#endif
+
 static int
 tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 {
@@ -2114,7 +2130,7 @@ tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 			v->data = (TDS_CHAR*) malloc(curcol->column_cur_size);
 			if (!v->data)
 				return TDS_FAIL;
-			if (tds_get_char_data(tds, (char *) v->data, colsize, curcol) == TDS_FAIL)
+			if (tds_get_char_data(tds, (char *) v, colsize, curcol) == TDS_FAIL)
 				return TDS_FAIL;
 			colsize = curcol->column_cur_size;
 			v->type = tds_get_cardinal_type(type, 0);

